/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	block.c - make/send/receive block
 */
#include "transit.h"


/*
 *  encode data
 */
makeBlock(encBuff, rawBuff)
unsigned char encBuff[], rawBuff[];
{
	register int length;
	register int i;
	int sum, crc;


	length = (rawBuff[DATALEN] & 0xff) + DATA;

	if (gmode == 1) {
		/* calculate crc */
		crc = 0;
		for (i = 0; i < length; i++) {
			crc = calc_crc((unsigned char)rawBuff[i], crc);
		}
		rawBuff[length    ] = (crc >> 8) & 0xff;
		rawBuff[length + 1] = (crc     ) & 0xff;

		encode7Block(encBuff, rawBuff);
	}
	else {
		/* calculate check sum */
		sum = 0;
		for (i = 0; i < length; i++) {
			sum += rawBuff[i];
		}
		rawBuff[length] = sum & 0xff;

		encode6Block(encBuff, rawBuff);
	}
}


/*
 *  write one block to RS
 */
writeBlock(buffer)
char buffer[];
{
	writeRsd(buffer, strlen(buffer));
	writeRsd("\r", 1);
}


waitBlock(buffer)
register char *buffer;
{
	static int leftLength = 0;
	static char leftBuff[LINESIZE];
	long timeNow, timeLimit;
	int length, i;
	register char *chp;


	time(&timeLimit);
	timeLimit += SHORTIME;	/* set time limit */

	/* copy data in buffer */
	for (chp = leftBuff; leftLength; --leftLength) {
		if (*chp == '\0') {	/* NULL code */
			++chp;	/* ignore */
		}
		else if ((*(buffer++) = *(chp++)) == '\r') {
			*(buffer - 1) = '\0';	/* terminate line */
			for (buffer = leftBuff; --leftLength;) {
				*(buffer++) = *(chp++);
			}	/* move left data */
			return (SUCCESS);
		}
	}

	for (time(&timeNow); timeNow < timeLimit; time(&timeNow)) {
		if (cgetc() == 0x03) {	/* ^C is pressed */
			quit();
		}
		if (i = rsdRetSize()) {
			if (i > LINESIZE) {
				i = LINESIZE;
			}
			i = readRsd(leftBuff, i);
			for (chp = leftBuff; i; --i) {
				if (*chp == '\0') {	/* NULL code */
					++chp;	/* ignore */
				}
				else if ((*(buffer++) = *(chp++)) == '\r') {
					*(buffer - 1) = '\0';
					leftLength = --i;
					for (buffer = leftBuff; i; --i) {
						*(buffer++) = *(chp++);
					}
					return (SUCCESS);
				}
			}
		}
	}
	return (TIMEOUT);
}


readBlock(rawbuff)
char rawbuff[];
{
	char encbuff[LINESIZE];
	register int i, length;


	if ((i = waitBlock(encbuff)) == TIMEOUT) {
		return (TIMEOUT);	/* time out */
	}
	else if (i == ERROR) {
		return (ERROR);	/* block error */
	}

	if (strlen(encbuff) < DATA + 1) {
		return (ERROR);	/* too short block */
	}

	if (gmode == 1) {
		if (decode7Block(rawbuff, encbuff) == ERROR) {
			return (ERROR);
		}
	}
	else {
		if (decode6Block(rawbuff, encbuff) == ERROR) {
			return (ERROR);
		}
	}

	return (rawbuff[DATALEN] & 0xff);
}
