/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	code6.c - encode/decode 6bit-encoded block
 */
#include "transit.h"


/*
 *  decode hc6 format to binary
 */
decode6Block(dp, sp)
register char *sp, *dp;
{
	register char sum, data, data1, data2, flag;


	/* decode */
	for (flag = 0, sum = 0; data = *sp++;) {
		if (G0LOW <= data && data <= G0HIGH) {
			data -= OFFSET0;
			switch (flag) {
			case 0:
				data1 = data;
				flag = 1;
				break;
			case 1:/* |765432|10xxxx| */
				data2 = data;
				sum += (*dp++ = (data1 << 2)
						+ ((data2 >> 4) & 0x3));
				flag = 2;
				break;
			case 2:/* |xx7654|3210xx| */
				data1 = data;
				sum += (*dp++ = (data2 << 4)
						+ ((data1 >> 2) & 0x0f));
				flag = 3;
				break;
			case 3:/* |xxxx76|543210| */
				sum += (*dp++ = (data1 << 6) + data);
				flag = 0;
				break;
			}
		}
	}
	sum -= (*(dp - 1) & 0xff);
	if ((sum & 0xff) != (*(dp - 1) & 0xff)) {
		return (ERROR);
	}
	return (SUCCESS);
}


/*
 *  encode binary to hc6 format
 */
encode6Block(dst, src)
register unsigned char *src, *dst;
{
	register unsigned int data, data1, flag, length;


	length = (*(src + DATALEN) & 0xff) + DATA + 1;
	for (flag = 0; length; --length) {
		data = *(src++) & 0xff;	/* byte data */
		switch (flag++) {
		case 0:	/* |765432|10xxxx| */
			*(dst++) = (data >> 2) + OFFSET0;
			data1 = (data << 4) & 0x30;
			break;
		case 1:	/* |xx7654|3210xx| */
			*(dst++) = (data >> 4) + data1 + OFFSET0;
			data1 = (data << 2) & 0x3c;
			break;
		case 2:	/* |xxxx76|543210| */
			*(dst++) = (data >> 6) + data1 + OFFSET0;
			*(dst++) = (data & 0x3f) + OFFSET0;
			flag = 0;
			break;
		}
	}
	if (flag != 0) {
		*(dst++) = data1 + OFFSET0;
	}

	/* terminate string */
	*dst = '\0';
}
