/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	disp.c - display status
 */
#include "transit.h"


static long sizeTotal;
static long sizeDone;
static long timeStart;
static int graph;

extern int blockAck;


dispinit(size)
long size;
{
	sizeTotal = size + 1;
	sizeDone  = 1L;
	graph = 0;

	/* read time */
	time(&timeStart);

	if (gopt == TRUE) {
		int i;

#ifdef DEBUG
		/* disp graph */
		for (i = 0; i < 79; i++)
			putlog('-');
		putlog('\r');
		fflush(logptr);
#endif
	}
}


dispstat(stat, size)
int stat;
int size;
{
	if (gopt == TRUE) {
		int i;

		switch (stat) {
		case NAK:
#ifdef DEBUG
			putlog('N');
			putlog('\b');
#endif
			break;
		case TIMEOUT:
#ifdef DEBUG
			putlog('T');
			putlog('\b');
#endif
			break;
		case ERROR:
#ifdef DEBUG
			putlog('E');
			putlog('\b');
#endif
			break;
		case SUCCESS:
			sizeDone += size;
#ifdef DEBUG
			i = (int)(79L * sizeDone / sizeTotal);
			while (graph < i) {
				putlog('#');
				graph++;
			}
#endif
			break;
		}
	}
	else {
		long timeNow;
		long sizeLeft;
		long timeLeft;

#ifdef DEBUG
		fprintf(logptr,"\r..Block #%d", blockAck);
#endif
		switch (stat) {
		case NAK:
#ifdef DEBUG
			fprintf(logptr,"..NAKed\033[K\n");
#endif
			break;
		case TIMEOUT:
#ifdef DEBUG
			fprintf(logptr,"..time out\033[K\n");
#endif
			break;
		case ERROR:
#ifdef DEBUG
			fprintf(logptr,"..error\033[K\n");
#endif
			break;
		case SUCCESS:
			sizeDone += size;
			time(&timeNow);
			sizeLeft = sizeTotal - sizeDone;
			timeLeft = sizeLeft * (timeNow - timeStart) / sizeDone;
#ifdef DEBUG
			fprintf(logptr,"..%ldbytes/%ldsec. remains\033[K",
						sizeLeft, timeLeft);
#endif
			break;
		}
	}
}


dispdone()
{
	long timeEnd;


	/* calculate time */
	time(&timeEnd);
	timeEnd -= timeStart;
	if (timeEnd == 0)
		timeEnd = 1;
#ifdef DEBUG
	fprintf(logptr,
		"\r..Transfer succeded (%ldsec. - %ldbytes/sec.)\033[K\n",
				timeEnd, (sizeTotal - 1) / timeEnd);
#endif
}
