/*
 *	File transfer protocol "TransIt"
 *		Version 2.00
 *	Copyright (C) 1987-1989 by ASCII Corporation.
 *
 *
 *	main.c - main routine
 */
#include "transit.h"


int gmode;
int oopt;
int topt;
int gopt;
int blockAck;

#ifdef DEBUG
FILE	*logptr;
#endif

static jmp_buf mainEnv;		/* environment to return to main() */

/*
 *  signal handler
 */
sigHandle()
{
#ifdef	DEBUG
	fputs("\n..User abort\007\007\n", logptr);
						/* show message */
#endif
	longjmp(mainEnv, QUIT);			/* return with ERROR code */
}

/*
 *  terminate transfer
 */
quit()
{
#ifdef DEBUG
	fputs("\n..Too many errors\007\007\n", logptr);
						/* show message */
#endif
	longjmp(mainEnv, QUIT);			/* return with ERROR code */
}

/*
 *  error abort
 */
abort()
{
#ifdef DEBUG
	fputs("\n..Terminate transfer\007\007\n", logptr);
						/* show message */
#endif
	longjmp(mainEnv, ABORT);		/* return with ERROR code */
}

/*
 *  main
 */
main(argc, argv)
int argc;
char *argv[];
{
	char ch, *chp;
	int result;
	char buffer[LINESIZE];
	int i;


	gmode = 0;
	oopt = FALSE;
	topt = FALSE;
	gopt = FALSE;

	/* set signal handler */
	signal(SIGINT, sigHandle);		/* set signal handler */

	rsdAttach();

	/* check argument */
	if (argc < 2) {
		fputs("transit <r[o][g]|s[t][g] {<path-name>}>\n", stderr);
	}
	else {
		++argv;
		ch = (*argv)[0];		/* command */
		for (i = 1; (*argv)[i]; i++) {
			switch ((*argv)[i]) {
			case 'o':		/* overwrite option */
				oopt = TRUE;
				break;
			case 't':
				topt = TRUE;	/* textmode option */
				break;
			case 'g':
				gopt = TRUE;	/* graph option */
				break;
			}
		}
		argc -= 2;
		++argv;				/* move forward pointer */
		if ((result = setjmp(mainEnv)) == 0) {	/* save environment */
			result = SUCCESS;
			if (ch == SENDCMD) {		/* send files */
				sendFile(argc, argv);
			}
			else if (ch == RECVCMD) {	/* recv files */
				recvFile(argc, argv);
			}
		}
		else {
			if (result == QUIT) {
				sendBytes(1, CONTROL, TERMINATE);
			}
			result = ERROR;
		}
	}

	rsdDetach();
	exit(result);
}
